; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    .code

start:
   
; 

    call main

    exit

; 

main proc

    LOCAL hMem  :DWORD
    LOCAL flen  :DWORD
    LOCAL wcnt  :DWORD
    LOCAL parr  :DWORD

    mov hMem, InputFile("\masm32\include\windows.inc")  ; load source file
    mov flen, ecx

    mov wcnt, rv(wtok,hMem,ADDR parr)       ; tokenise words in source

    print "File tokenised",13,10
    print "Press CTRL + C if you get bored watching tokenised text",13,10

    inkey                   ; wait for user key press

    push esi                ; preserve ESI and EDI
    push edi

    mov esi, parr           ; load array address into ESI
    mov edi, wcnt           ; put word count in EDI

  @@:
    print [esi],13,10       ; display data at ADDRESS in ESI
    add esi, 4              ; step up to next address in ESI
    sub edi, 1              ; decrement counter
    jnz @B

    pop edi                 ; restore EDI and ESI
    pop esi

    ret

main endp

; 

end start
